# coding: utf-8

"""
    UbiOps

    Client Library to interact with the UbiOps API.

    The version of the OpenAPI document: v2.1
    Generated by: https://openapi-generator.tech
"""


import pprint


class AttachmentSourcesList(object):
    """
    NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name and the value is attribute type
      attribute_map (dict): The key is attribute name and the value is json key in definition
    """

    openapi_types = {"source_name": "str", "mapping": "list[AttachmentFieldsList]"}

    attribute_map = {"source_name": "source_name", "mapping": "mapping"}

    def __init__(self, source_name=None, mapping=None, **kwargs):
        """
        AttachmentSourcesList - a model defined in OpenAPI
        """

        self.client_side_validation = True
        if "local_vars_configuration" in kwargs and kwargs["local_vars_configuration"] is not None:
            self.client_side_validation = kwargs["local_vars_configuration"].client_side_validation

        self._source_name = None
        self._mapping = None
        self.discriminator = None

        self.source_name = source_name
        if mapping is not None:
            self.mapping = mapping

    @property
    def source_name(self):
        """
        Gets the source_name of this AttachmentSourcesList

        :return: the source_name of this AttachmentSourcesList
        :rtype: str
        """

        return self._source_name

    @source_name.setter
    def source_name(self, source_name):
        """
        Sets the source_name of this AttachmentSourcesList

        :param source_name: the source_name of this AttachmentSourcesList
        :type: str
        """

        if self.client_side_validation and source_name is None:
            raise ValueError("Invalid value for `source_name`, must not be `None`")
        if self.client_side_validation and (source_name is not None and not isinstance(source_name, str)):
            raise ValueError("Parameter `source_name` must be a string")

        if self.client_side_validation and (source_name is not None and len(source_name) < 1):
            raise ValueError("Invalid value for `source_name`, length must be greater than or equal to `1`")

        self._source_name = source_name

    @property
    def mapping(self):
        """
        Gets the mapping of this AttachmentSourcesList

        :return: the mapping of this AttachmentSourcesList
        :rtype: list[AttachmentFieldsList]
        """

        return self._mapping

    @mapping.setter
    def mapping(self, mapping):
        """
        Sets the mapping of this AttachmentSourcesList

        :param mapping: the mapping of this AttachmentSourcesList
        :type: list[AttachmentFieldsList]
        """

        if self.client_side_validation and (mapping is not None and not isinstance(mapping, list)):
            raise ValueError("Parameter `mapping` must be a list")
        if self.client_side_validation and mapping is not None:
            from ubiops.models.attachment_fields_list import AttachmentFieldsList

            mapping = [AttachmentFieldsList(**item) if isinstance(item, dict) else item for item in mapping]

        self._mapping = mapping

    def to_dict(self):
        """
        Returns the model properties as a dict
        """

        result = {}

        for attr, _ in self.openapi_types.items():
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(lambda x: x.to_dict() if hasattr(x, "to_dict") else x, value))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(
                    map(
                        lambda item: (item[0], item[1].to_dict()) if hasattr(item[1], "to_dict") else item,
                        value.items(),
                    )
                )
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """

        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """

        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """

        if not isinstance(other, AttachmentSourcesList):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """

        if not isinstance(other, AttachmentSourcesList):
            return True

        return self.to_dict() != other.to_dict()
