# coding: utf-8

"""
    UbiOps

    Client Library to interact with the UbiOps API.

    The version of the OpenAPI document: v2.1
    Generated by: https://openapi-generator.tech
"""


import pprint


class DeploymentUpdate(object):
    """
    NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name and the value is attribute type
      attribute_map (dict): The key is attribute name and the value is json key in definition
    """

    openapi_types = {
        "name": "str",
        "default_version": "str",
        "description": "str",
        "input_fields": "list[DeploymentInputFieldCreate]",
        "output_fields": "list[DeploymentOutputFieldCreate]",
        "labels": "dict(str, str)",
    }

    attribute_map = {
        "name": "name",
        "default_version": "default_version",
        "description": "description",
        "input_fields": "input_fields",
        "output_fields": "output_fields",
        "labels": "labels",
    }

    def __init__(
        self,
        name=None,
        default_version=None,
        description=None,
        input_fields=None,
        output_fields=None,
        labels=None,
        **kwargs,
    ):
        """
        DeploymentUpdate - a model defined in OpenAPI
        """

        self.client_side_validation = True
        if "local_vars_configuration" in kwargs and kwargs["local_vars_configuration"] is not None:
            self.client_side_validation = kwargs["local_vars_configuration"].client_side_validation

        self._name = None
        self._default_version = None
        self._description = None
        self._input_fields = None
        self._output_fields = None
        self._labels = None
        self.discriminator = None

        if name is not None:
            self.name = name
        if default_version is not None:
            self.default_version = default_version
        if description is not None:
            self.description = description
        if input_fields is not None:
            self.input_fields = input_fields
        if output_fields is not None:
            self.output_fields = output_fields
        if labels is not None:
            self.labels = labels

    @property
    def name(self):
        """
        Gets the name of this DeploymentUpdate

        :return: the name of this DeploymentUpdate
        :rtype: str
        """

        return self._name

    @name.setter
    def name(self, name):
        """
        Sets the name of this DeploymentUpdate

        :param name: the name of this DeploymentUpdate
        :type: str
        """

        if self.client_side_validation and (name is not None and not isinstance(name, str)):
            raise ValueError("Parameter `name` must be a string")

        if self.client_side_validation and (name is not None and len(name) < 1):
            raise ValueError("Invalid value for `name`, length must be greater than or equal to `1`")

        self._name = name

    @property
    def default_version(self):
        """
        Gets the default_version of this DeploymentUpdate

        :return: the default_version of this DeploymentUpdate
        :rtype: str
        """

        return self._default_version

    @default_version.setter
    def default_version(self, default_version):
        """
        Sets the default_version of this DeploymentUpdate

        :param default_version: the default_version of this DeploymentUpdate
        :type: str
        """

        if self.client_side_validation and (default_version is not None and not isinstance(default_version, str)):
            raise ValueError("Parameter `default_version` must be a string")

        if self.client_side_validation and (default_version is not None and len(default_version) < 1):
            raise ValueError("Invalid value for `default_version`, length must be greater than or equal to `1`")

        self._default_version = default_version

    @property
    def description(self):
        """
        Gets the description of this DeploymentUpdate

        :return: the description of this DeploymentUpdate
        :rtype: str
        """

        return self._description

    @description.setter
    def description(self, description):
        """
        Sets the description of this DeploymentUpdate

        :param description: the description of this DeploymentUpdate
        :type: str
        """

        if self.client_side_validation and (description is not None and not isinstance(description, str)):
            raise ValueError("Parameter `description` must be a string")

        self._description = description

    @property
    def input_fields(self):
        """
        Gets the input_fields of this DeploymentUpdate

        :return: the input_fields of this DeploymentUpdate
        :rtype: list[DeploymentInputFieldCreate]
        """

        return self._input_fields

    @input_fields.setter
    def input_fields(self, input_fields):
        """
        Sets the input_fields of this DeploymentUpdate

        :param input_fields: the input_fields of this DeploymentUpdate
        :type: list[DeploymentInputFieldCreate]
        """

        if self.client_side_validation and (input_fields is not None and not isinstance(input_fields, list)):
            raise ValueError("Parameter `input_fields` must be a list")
        if self.client_side_validation and input_fields is not None:
            from ubiops.models.deployment_input_field_create import DeploymentInputFieldCreate

            input_fields = [
                DeploymentInputFieldCreate(**item) if isinstance(item, dict) else item for item in input_fields
            ]

        self._input_fields = input_fields

    @property
    def output_fields(self):
        """
        Gets the output_fields of this DeploymentUpdate

        :return: the output_fields of this DeploymentUpdate
        :rtype: list[DeploymentOutputFieldCreate]
        """

        return self._output_fields

    @output_fields.setter
    def output_fields(self, output_fields):
        """
        Sets the output_fields of this DeploymentUpdate

        :param output_fields: the output_fields of this DeploymentUpdate
        :type: list[DeploymentOutputFieldCreate]
        """

        if self.client_side_validation and (output_fields is not None and not isinstance(output_fields, list)):
            raise ValueError("Parameter `output_fields` must be a list")
        if self.client_side_validation and output_fields is not None:
            from ubiops.models.deployment_output_field_create import DeploymentOutputFieldCreate

            output_fields = [
                DeploymentOutputFieldCreate(**item) if isinstance(item, dict) else item for item in output_fields
            ]

        self._output_fields = output_fields

    @property
    def labels(self):
        """
        Gets the labels of this DeploymentUpdate

        :return: the labels of this DeploymentUpdate
        :rtype: dict(str, str)
        """

        return self._labels

    @labels.setter
    def labels(self, labels):
        """
        Sets the labels of this DeploymentUpdate

        :param labels: the labels of this DeploymentUpdate
        :type: dict(str, str)
        """

        if self.client_side_validation and (labels is not None and not isinstance(labels, dict)):
            raise ValueError("Parameter `labels` must be a dictionary")

        self._labels = labels

    def to_dict(self):
        """
        Returns the model properties as a dict
        """

        result = {}

        for attr, _ in self.openapi_types.items():
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(lambda x: x.to_dict() if hasattr(x, "to_dict") else x, value))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(
                    map(
                        lambda item: (item[0], item[1].to_dict()) if hasattr(item[1], "to_dict") else item,
                        value.items(),
                    )
                )
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """

        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """

        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """

        if not isinstance(other, DeploymentUpdate):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """

        if not isinstance(other, DeploymentUpdate):
            return True

        return self.to_dict() != other.to_dict()
