# coding: utf-8

"""
    UbiOps

    Client Library to interact with the UbiOps API.

    The version of the OpenAPI document: v2.1
    Generated by: https://openapi-generator.tech
"""


import pprint


class EnvironmentVariableList(object):
    """
    NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name and the value is attribute type
      attribute_map (dict): The key is attribute name and the value is json key in definition
    """

    openapi_types = {"id": "str", "name": "str", "value": "str", "secret": "bool"}

    attribute_map = {"id": "id", "name": "name", "value": "value", "secret": "secret"}

    def __init__(self, id=None, name=None, value=None, secret=None, **kwargs):
        """
        EnvironmentVariableList - a model defined in OpenAPI
        """

        self.client_side_validation = True
        if "local_vars_configuration" in kwargs and kwargs["local_vars_configuration"] is not None:
            self.client_side_validation = kwargs["local_vars_configuration"].client_side_validation

        self._id = None
        self._name = None
        self._value = None
        self._secret = None
        self.discriminator = None

        if id is not None:
            self.id = id
        self.name = name
        self.value = value
        self.secret = secret

    @property
    def id(self):
        """
        Gets the id of this EnvironmentVariableList

        :return: the id of this EnvironmentVariableList
        :rtype: str
        """

        return self._id

    @id.setter
    def id(self, id):
        """
        Sets the id of this EnvironmentVariableList

        :param id: the id of this EnvironmentVariableList
        :type: str
        """

        if self.client_side_validation and (id is not None and not isinstance(id, str)):
            raise ValueError("Parameter `id` must be a string")

        self._id = id

    @property
    def name(self):
        """
        Gets the name of this EnvironmentVariableList

        :return: the name of this EnvironmentVariableList
        :rtype: str
        """

        return self._name

    @name.setter
    def name(self, name):
        """
        Sets the name of this EnvironmentVariableList

        :param name: the name of this EnvironmentVariableList
        :type: str
        """

        if self.client_side_validation and name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")
        if self.client_side_validation and (name is not None and not isinstance(name, str)):
            raise ValueError("Parameter `name` must be a string")

        if self.client_side_validation and (name is not None and len(name) > 64):
            raise ValueError("Invalid value for `name`, length must be less than or equal to `64`")
        if self.client_side_validation and (name is not None and len(name) < 1):
            raise ValueError("Invalid value for `name`, length must be greater than or equal to `1`")

        self._name = name

    @property
    def value(self):
        """
        Gets the value of this EnvironmentVariableList

        :return: the value of this EnvironmentVariableList
        :rtype: str
        """

        return self._value

    @value.setter
    def value(self, value):
        """
        Sets the value of this EnvironmentVariableList

        :param value: the value of this EnvironmentVariableList
        :type: str
        """

        if self.client_side_validation and (value is not None and not isinstance(value, str)):
            raise ValueError("Parameter `value` must be a string")

        self._value = value

    @property
    def secret(self):
        """
        Gets the secret of this EnvironmentVariableList

        :return: the secret of this EnvironmentVariableList
        :rtype: bool
        """

        return self._secret

    @secret.setter
    def secret(self, secret):
        """
        Sets the secret of this EnvironmentVariableList

        :param secret: the secret of this EnvironmentVariableList
        :type: bool
        """

        if self.client_side_validation and secret is None:
            raise ValueError("Invalid value for `secret`, must not be `None`")
        if self.client_side_validation and (secret is not None and not isinstance(secret, bool)):
            raise ValueError("Parameter `secret` must be a boolean")

        self._secret = secret

    def to_dict(self):
        """
        Returns the model properties as a dict
        """

        result = {}

        for attr, _ in self.openapi_types.items():
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(lambda x: x.to_dict() if hasattr(x, "to_dict") else x, value))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(
                    map(
                        lambda item: (item[0], item[1].to_dict()) if hasattr(item[1], "to_dict") else item,
                        value.items(),
                    )
                )
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """

        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """

        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """

        if not isinstance(other, EnvironmentVariableList):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """

        if not isinstance(other, EnvironmentVariableList):
            return True

        return self.to_dict() != other.to_dict()
