# coding: utf-8

"""
    UbiOps

    Client Library to interact with the UbiOps API.

    The version of the OpenAPI document: v2.1
    Generated by: https://openapi-generator.tech
"""


import pprint


class ExportDetail(object):
    """
    NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name and the value is attribute type
      attribute_map (dict): The key is attribute name and the value is json key in definition
    """

    openapi_types = {
        "id": "str",
        "exported_by": "str",
        "creation_date": "datetime",
        "status": "str",
        "error_message": "str",
        "size": "int",
        "description": "str",
        "deployments": "dict(str, object)",
        "pipelines": "dict(str, object)",
        "environment_variables": "dict(str, object)",
        "environments": "dict(str, object)",
    }

    attribute_map = {
        "id": "id",
        "exported_by": "exported_by",
        "creation_date": "creation_date",
        "status": "status",
        "error_message": "error_message",
        "size": "size",
        "description": "description",
        "deployments": "deployments",
        "pipelines": "pipelines",
        "environment_variables": "environment_variables",
        "environments": "environments",
    }

    def __init__(
        self,
        id=None,
        exported_by=None,
        creation_date=None,
        status="pending",
        error_message=None,
        size=None,
        description=None,
        deployments=None,
        pipelines=None,
        environment_variables=None,
        environments=None,
        **kwargs,
    ):
        """
        ExportDetail - a model defined in OpenAPI
        """

        self.client_side_validation = True
        if "local_vars_configuration" in kwargs and kwargs["local_vars_configuration"] is not None:
            self.client_side_validation = kwargs["local_vars_configuration"].client_side_validation

        self._id = None
        self._exported_by = None
        self._creation_date = None
        self._status = None
        self._error_message = None
        self._size = None
        self._description = None
        self._deployments = None
        self._pipelines = None
        self._environment_variables = None
        self._environments = None
        self.discriminator = None

        if id is not None:
            self.id = id
        if exported_by is not None:
            self.exported_by = exported_by
        if creation_date is not None:
            self.creation_date = creation_date
        if status is not None:
            self.status = status
        self.error_message = error_message
        self.size = size
        self.description = description
        if deployments is not None:
            self.deployments = deployments
        if pipelines is not None:
            self.pipelines = pipelines
        if environment_variables is not None:
            self.environment_variables = environment_variables
        if environments is not None:
            self.environments = environments

    @property
    def id(self):
        """
        Gets the id of this ExportDetail

        :return: the id of this ExportDetail
        :rtype: str
        """

        return self._id

    @id.setter
    def id(self, id):
        """
        Sets the id of this ExportDetail

        :param id: the id of this ExportDetail
        :type: str
        """

        if self.client_side_validation and (id is not None and not isinstance(id, str)):
            raise ValueError("Parameter `id` must be a string")

        self._id = id

    @property
    def exported_by(self):
        """
        Gets the exported_by of this ExportDetail

        :return: the exported_by of this ExportDetail
        :rtype: str
        """

        return self._exported_by

    @exported_by.setter
    def exported_by(self, exported_by):
        """
        Sets the exported_by of this ExportDetail

        :param exported_by: the exported_by of this ExportDetail
        :type: str
        """

        if self.client_side_validation and (exported_by is not None and not isinstance(exported_by, str)):
            raise ValueError("Parameter `exported_by` must be a string")

        self._exported_by = exported_by

    @property
    def creation_date(self):
        """
        Gets the creation_date of this ExportDetail

        :return: the creation_date of this ExportDetail
        :rtype: datetime
        """

        return self._creation_date

    @creation_date.setter
    def creation_date(self, creation_date):
        """
        Sets the creation_date of this ExportDetail

        :param creation_date: the creation_date of this ExportDetail
        :type: datetime
        """

        self._creation_date = creation_date

    @property
    def status(self):
        """
        Gets the status of this ExportDetail

        :return: the status of this ExportDetail
        :rtype: str
        """

        return self._status

    @status.setter
    def status(self, status):
        """
        Sets the status of this ExportDetail

        :param status: the status of this ExportDetail
        :type: str
        """

        if self.client_side_validation and (status is not None and not isinstance(status, str)):
            raise ValueError("Parameter `status` must be a string")

        self._status = status

    @property
    def error_message(self):
        """
        Gets the error_message of this ExportDetail

        :return: the error_message of this ExportDetail
        :rtype: str
        """

        return self._error_message

    @error_message.setter
    def error_message(self, error_message):
        """
        Sets the error_message of this ExportDetail

        :param error_message: the error_message of this ExportDetail
        :type: str
        """

        if self.client_side_validation and (error_message is not None and not isinstance(error_message, str)):
            raise ValueError("Parameter `error_message` must be a string")

        if self.client_side_validation and (error_message is not None and len(error_message) > 1024):
            raise ValueError("Invalid value for `error_message`, length must be less than or equal to `1024`")

        self._error_message = error_message

    @property
    def size(self):
        """
        Gets the size of this ExportDetail

        :return: the size of this ExportDetail
        :rtype: int
        """

        return self._size

    @size.setter
    def size(self, size):
        """
        Sets the size of this ExportDetail

        :param size: the size of this ExportDetail
        :type: int
        """

        if self.client_side_validation and (size is not None and not isinstance(size, int)):
            raise ValueError("Parameter `size` must be an integer")

        self._size = size

    @property
    def description(self):
        """
        Gets the description of this ExportDetail

        :return: the description of this ExportDetail
        :rtype: str
        """

        return self._description

    @description.setter
    def description(self, description):
        """
        Sets the description of this ExportDetail

        :param description: the description of this ExportDetail
        :type: str
        """

        if self.client_side_validation and (description is not None and not isinstance(description, str)):
            raise ValueError("Parameter `description` must be a string")

        if self.client_side_validation and (description is not None and len(description) > 400):
            raise ValueError("Invalid value for `description`, length must be less than or equal to `400`")

        self._description = description

    @property
    def deployments(self):
        """
        Gets the deployments of this ExportDetail

        :return: the deployments of this ExportDetail
        :rtype: dict(str, object)
        """

        return self._deployments

    @deployments.setter
    def deployments(self, deployments):
        """
        Sets the deployments of this ExportDetail

        :param deployments: the deployments of this ExportDetail
        :type: dict(str, object)
        """

        if self.client_side_validation and (deployments is not None and not isinstance(deployments, dict)):
            raise ValueError("Parameter `deployments` must be a dictionary")

        self._deployments = deployments

    @property
    def pipelines(self):
        """
        Gets the pipelines of this ExportDetail

        :return: the pipelines of this ExportDetail
        :rtype: dict(str, object)
        """

        return self._pipelines

    @pipelines.setter
    def pipelines(self, pipelines):
        """
        Sets the pipelines of this ExportDetail

        :param pipelines: the pipelines of this ExportDetail
        :type: dict(str, object)
        """

        if self.client_side_validation and (pipelines is not None and not isinstance(pipelines, dict)):
            raise ValueError("Parameter `pipelines` must be a dictionary")

        self._pipelines = pipelines

    @property
    def environment_variables(self):
        """
        Gets the environment_variables of this ExportDetail

        :return: the environment_variables of this ExportDetail
        :rtype: dict(str, object)
        """

        return self._environment_variables

    @environment_variables.setter
    def environment_variables(self, environment_variables):
        """
        Sets the environment_variables of this ExportDetail

        :param environment_variables: the environment_variables of this ExportDetail
        :type: dict(str, object)
        """

        if self.client_side_validation and (
            environment_variables is not None and not isinstance(environment_variables, dict)
        ):
            raise ValueError("Parameter `environment_variables` must be a dictionary")

        self._environment_variables = environment_variables

    @property
    def environments(self):
        """
        Gets the environments of this ExportDetail

        :return: the environments of this ExportDetail
        :rtype: dict(str, object)
        """

        return self._environments

    @environments.setter
    def environments(self, environments):
        """
        Sets the environments of this ExportDetail

        :param environments: the environments of this ExportDetail
        :type: dict(str, object)
        """

        if self.client_side_validation and (environments is not None and not isinstance(environments, dict)):
            raise ValueError("Parameter `environments` must be a dictionary")

        self._environments = environments

    def to_dict(self):
        """
        Returns the model properties as a dict
        """

        result = {}

        for attr, _ in self.openapi_types.items():
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(lambda x: x.to_dict() if hasattr(x, "to_dict") else x, value))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(
                    map(
                        lambda item: (item[0], item[1].to_dict()) if hasattr(item[1], "to_dict") else item,
                        value.items(),
                    )
                )
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """

        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """

        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """

        if not isinstance(other, ExportDetail):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """

        if not isinstance(other, ExportDetail):
            return True

        return self.to_dict() != other.to_dict()
