# coding: utf-8

"""
    UbiOps

    Client Library to interact with the UbiOps API.

    The version of the OpenAPI document: v2.1
    Generated by: https://openapi-generator.tech
"""


import pprint


class FileItem(object):
    """
    NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name and the value is attribute type
      attribute_map (dict): The key is attribute name and the value is json key in definition
    """

    openapi_types = {"file": "str", "size": "int", "time_created": "datetime"}

    attribute_map = {"file": "file", "size": "size", "time_created": "time_created"}

    def __init__(self, file=None, size=None, time_created=None, **kwargs):
        """
        FileItem - a model defined in OpenAPI
        """

        self.client_side_validation = True
        if "local_vars_configuration" in kwargs and kwargs["local_vars_configuration"] is not None:
            self.client_side_validation = kwargs["local_vars_configuration"].client_side_validation

        self._file = None
        self._size = None
        self._time_created = None
        self.discriminator = None

        self.file = file
        self.size = size
        if time_created is not None:
            self.time_created = time_created

    @property
    def file(self):
        """
        Gets the file of this FileItem

        :return: the file of this FileItem
        :rtype: str
        """

        return self._file

    @file.setter
    def file(self, file):
        """
        Sets the file of this FileItem

        :param file: the file of this FileItem
        :type: str
        """

        if self.client_side_validation and file is None:
            raise ValueError("Invalid value for `file`, must not be `None`")
        if self.client_side_validation and (file is not None and not isinstance(file, str)):
            raise ValueError("Parameter `file` must be a string")

        self._file = file

    @property
    def size(self):
        """
        Gets the size of this FileItem

        :return: the size of this FileItem
        :rtype: int
        """

        return self._size

    @size.setter
    def size(self, size):
        """
        Sets the size of this FileItem

        :param size: the size of this FileItem
        :type: int
        """

        if self.client_side_validation and (size is not None and not isinstance(size, int)):
            raise ValueError("Parameter `size` must be an integer")

        self._size = size

    @property
    def time_created(self):
        """
        Gets the time_created of this FileItem

        :return: the time_created of this FileItem
        :rtype: datetime
        """

        return self._time_created

    @time_created.setter
    def time_created(self, time_created):
        """
        Sets the time_created of this FileItem

        :param time_created: the time_created of this FileItem
        :type: datetime
        """

        self._time_created = time_created

    def to_dict(self):
        """
        Returns the model properties as a dict
        """

        result = {}

        for attr, _ in self.openapi_types.items():
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(lambda x: x.to_dict() if hasattr(x, "to_dict") else x, value))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(
                    map(
                        lambda item: (item[0], item[1].to_dict()) if hasattr(item[1], "to_dict") else item,
                        value.items(),
                    )
                )
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """

        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """

        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """

        if not isinstance(other, FileItem):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """

        if not isinstance(other, FileItem):
            return True

        return self.to_dict() != other.to_dict()
