# coding: utf-8

"""
    UbiOps

    Client Library to interact with the UbiOps API.

    The version of the OpenAPI document: v2.1
    Generated by: https://openapi-generator.tech
"""


import pprint


class InstanceTypeGroupList(object):
    """
    NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name and the value is attribute type
      attribute_map (dict): The key is attribute name and the value is json key in definition
    """

    openapi_types = {
        "id": "str",
        "name": "str",
        "time_created": "datetime",
        "time_updated": "datetime",
        "instance_types": "list[InstanceTypeItem]",
    }

    attribute_map = {
        "id": "id",
        "name": "name",
        "time_created": "time_created",
        "time_updated": "time_updated",
        "instance_types": "instance_types",
    }

    def __init__(self, id=None, name=None, time_created=None, time_updated=None, instance_types=None, **kwargs):
        """
        InstanceTypeGroupList - a model defined in OpenAPI
        """

        self.client_side_validation = True
        if "local_vars_configuration" in kwargs and kwargs["local_vars_configuration"] is not None:
            self.client_side_validation = kwargs["local_vars_configuration"].client_side_validation

        self._id = None
        self._name = None
        self._time_created = None
        self._time_updated = None
        self._instance_types = None
        self.discriminator = None

        self.id = id
        self.name = name
        self.time_created = time_created
        self.time_updated = time_updated
        if instance_types is not None:
            self.instance_types = instance_types

    @property
    def id(self):
        """
        Gets the id of this InstanceTypeGroupList

        :return: the id of this InstanceTypeGroupList
        :rtype: str
        """

        return self._id

    @id.setter
    def id(self, id):
        """
        Sets the id of this InstanceTypeGroupList

        :param id: the id of this InstanceTypeGroupList
        :type: str
        """

        if self.client_side_validation and id is None:
            raise ValueError("Invalid value for `id`, must not be `None`")
        if self.client_side_validation and (id is not None and not isinstance(id, str)):
            raise ValueError("Parameter `id` must be a string")

        self._id = id

    @property
    def name(self):
        """
        Gets the name of this InstanceTypeGroupList

        :return: the name of this InstanceTypeGroupList
        :rtype: str
        """

        return self._name

    @name.setter
    def name(self, name):
        """
        Sets the name of this InstanceTypeGroupList

        :param name: the name of this InstanceTypeGroupList
        :type: str
        """

        if self.client_side_validation and (name is not None and not isinstance(name, str)):
            raise ValueError("Parameter `name` must be a string")

        self._name = name

    @property
    def time_created(self):
        """
        Gets the time_created of this InstanceTypeGroupList

        :return: the time_created of this InstanceTypeGroupList
        :rtype: datetime
        """

        return self._time_created

    @time_created.setter
    def time_created(self, time_created):
        """
        Sets the time_created of this InstanceTypeGroupList

        :param time_created: the time_created of this InstanceTypeGroupList
        :type: datetime
        """

        self._time_created = time_created

    @property
    def time_updated(self):
        """
        Gets the time_updated of this InstanceTypeGroupList

        :return: the time_updated of this InstanceTypeGroupList
        :rtype: datetime
        """

        return self._time_updated

    @time_updated.setter
    def time_updated(self, time_updated):
        """
        Sets the time_updated of this InstanceTypeGroupList

        :param time_updated: the time_updated of this InstanceTypeGroupList
        :type: datetime
        """

        self._time_updated = time_updated

    @property
    def instance_types(self):
        """
        Gets the instance_types of this InstanceTypeGroupList

        :return: the instance_types of this InstanceTypeGroupList
        :rtype: list[InstanceTypeItem]
        """

        return self._instance_types

    @instance_types.setter
    def instance_types(self, instance_types):
        """
        Sets the instance_types of this InstanceTypeGroupList

        :param instance_types: the instance_types of this InstanceTypeGroupList
        :type: list[InstanceTypeItem]
        """

        if self.client_side_validation and (instance_types is not None and not isinstance(instance_types, list)):
            raise ValueError("Parameter `instance_types` must be a list")
        if self.client_side_validation and instance_types is not None:
            from ubiops.models.instance_type_item import InstanceTypeItem

            instance_types = [InstanceTypeItem(**item) if isinstance(item, dict) else item for item in instance_types]

        self._instance_types = instance_types

    def to_dict(self):
        """
        Returns the model properties as a dict
        """

        result = {}

        for attr, _ in self.openapi_types.items():
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(lambda x: x.to_dict() if hasattr(x, "to_dict") else x, value))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(
                    map(
                        lambda item: (item[0], item[1].to_dict()) if hasattr(item[1], "to_dict") else item,
                        value.items(),
                    )
                )
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """

        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """

        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """

        if not isinstance(other, InstanceTypeGroupList):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """

        if not isinstance(other, InstanceTypeGroupList):
            return True

        return self.to_dict() != other.to_dict()
