# coding: utf-8

"""
    UbiOps

    Client Library to interact with the UbiOps API.

    The version of the OpenAPI document: v2.1
    Generated by: https://openapi-generator.tech
"""


import pprint


class MetricDetail(object):
    """
    NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name and the value is attribute type
      attribute_map (dict): The key is attribute name and the value is json key in definition
    """

    openapi_types = {
        "id": "int",
        "name": "str",
        "description": "str",
        "creation_date": "datetime",
        "last_updated": "datetime",
        "custom": "bool",
        "metric_type": "str",
        "unit": "str",
        "labels": "list[str]",
    }

    attribute_map = {
        "id": "id",
        "name": "name",
        "description": "description",
        "creation_date": "creation_date",
        "last_updated": "last_updated",
        "custom": "custom",
        "metric_type": "metric_type",
        "unit": "unit",
        "labels": "labels",
    }

    def __init__(
        self,
        id=None,
        name=None,
        description=None,
        creation_date=None,
        last_updated=None,
        custom=None,
        metric_type=None,
        unit=None,
        labels=None,
        **kwargs,
    ):
        """
        MetricDetail - a model defined in OpenAPI
        """

        self.client_side_validation = True
        if "local_vars_configuration" in kwargs and kwargs["local_vars_configuration"] is not None:
            self.client_side_validation = kwargs["local_vars_configuration"].client_side_validation

        self._id = None
        self._name = None
        self._description = None
        self._creation_date = None
        self._last_updated = None
        self._custom = None
        self._metric_type = None
        self._unit = None
        self._labels = None
        self.discriminator = None

        if id is not None:
            self.id = id
        self.name = name
        if description is not None:
            self.description = description
        if creation_date is not None:
            self.creation_date = creation_date
        if last_updated is not None:
            self.last_updated = last_updated
        if custom is not None:
            self.custom = custom
        if metric_type is not None:
            self.metric_type = metric_type
        if unit is not None:
            self.unit = unit
        if labels is not None:
            self.labels = labels

    @property
    def id(self):
        """
        Gets the id of this MetricDetail

        :return: the id of this MetricDetail
        :rtype: int
        """

        return self._id

    @id.setter
    def id(self, id):
        """
        Sets the id of this MetricDetail

        :param id: the id of this MetricDetail
        :type: int
        """

        if self.client_side_validation and (id is not None and not isinstance(id, int)):
            raise ValueError("Parameter `id` must be an integer")

        self._id = id

    @property
    def name(self):
        """
        Gets the name of this MetricDetail

        :return: the name of this MetricDetail
        :rtype: str
        """

        return self._name

    @name.setter
    def name(self, name):
        """
        Sets the name of this MetricDetail

        :param name: the name of this MetricDetail
        :type: str
        """

        if self.client_side_validation and name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")
        if self.client_side_validation and (name is not None and not isinstance(name, str)):
            raise ValueError("Parameter `name` must be a string")

        if self.client_side_validation and (name is not None and len(name) > 64):
            raise ValueError("Invalid value for `name`, length must be less than or equal to `64`")
        if self.client_side_validation and (name is not None and len(name) < 1):
            raise ValueError("Invalid value for `name`, length must be greater than or equal to `1`")

        self._name = name

    @property
    def description(self):
        """
        Gets the description of this MetricDetail

        :return: the description of this MetricDetail
        :rtype: str
        """

        return self._description

    @description.setter
    def description(self, description):
        """
        Sets the description of this MetricDetail

        :param description: the description of this MetricDetail
        :type: str
        """

        if self.client_side_validation and (description is not None and not isinstance(description, str)):
            raise ValueError("Parameter `description` must be a string")

        if self.client_side_validation and (description is not None and len(description) > 400):
            raise ValueError("Invalid value for `description`, length must be less than or equal to `400`")

        self._description = description

    @property
    def creation_date(self):
        """
        Gets the creation_date of this MetricDetail

        :return: the creation_date of this MetricDetail
        :rtype: datetime
        """

        return self._creation_date

    @creation_date.setter
    def creation_date(self, creation_date):
        """
        Sets the creation_date of this MetricDetail

        :param creation_date: the creation_date of this MetricDetail
        :type: datetime
        """

        self._creation_date = creation_date

    @property
    def last_updated(self):
        """
        Gets the last_updated of this MetricDetail

        :return: the last_updated of this MetricDetail
        :rtype: datetime
        """

        return self._last_updated

    @last_updated.setter
    def last_updated(self, last_updated):
        """
        Sets the last_updated of this MetricDetail

        :param last_updated: the last_updated of this MetricDetail
        :type: datetime
        """

        self._last_updated = last_updated

    @property
    def custom(self):
        """
        Gets the custom of this MetricDetail

        :return: the custom of this MetricDetail
        :rtype: bool
        """

        return self._custom

    @custom.setter
    def custom(self, custom):
        """
        Sets the custom of this MetricDetail

        :param custom: the custom of this MetricDetail
        :type: bool
        """

        if self.client_side_validation and (custom is not None and not isinstance(custom, bool)):
            raise ValueError("Parameter `custom` must be a boolean")

        self._custom = custom

    @property
    def metric_type(self):
        """
        Gets the metric_type of this MetricDetail

        :return: the metric_type of this MetricDetail
        :rtype: str
        """

        return self._metric_type

    @metric_type.setter
    def metric_type(self, metric_type):
        """
        Sets the metric_type of this MetricDetail

        :param metric_type: the metric_type of this MetricDetail
        :type: str
        """

        if self.client_side_validation and (metric_type is not None and not isinstance(metric_type, str)):
            raise ValueError("Parameter `metric_type` must be a string")

        self._metric_type = metric_type

    @property
    def unit(self):
        """
        Gets the unit of this MetricDetail

        :return: the unit of this MetricDetail
        :rtype: str
        """

        return self._unit

    @unit.setter
    def unit(self, unit):
        """
        Sets the unit of this MetricDetail

        :param unit: the unit of this MetricDetail
        :type: str
        """

        if self.client_side_validation and (unit is not None and not isinstance(unit, str)):
            raise ValueError("Parameter `unit` must be a string")

        if self.client_side_validation and (unit is not None and len(unit) > 32):
            raise ValueError("Invalid value for `unit`, length must be less than or equal to `32`")

        self._unit = unit

    @property
    def labels(self):
        """
        Gets the labels of this MetricDetail

        :return: the labels of this MetricDetail
        :rtype: list[str]
        """

        return self._labels

    @labels.setter
    def labels(self, labels):
        """
        Sets the labels of this MetricDetail

        :param labels: the labels of this MetricDetail
        :type: list[str]
        """

        if self.client_side_validation and (labels is not None and not isinstance(labels, list)):
            raise ValueError("Parameter `labels` must be a list")

        self._labels = labels

    def to_dict(self):
        """
        Returns the model properties as a dict
        """

        result = {}

        for attr, _ in self.openapi_types.items():
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(lambda x: x.to_dict() if hasattr(x, "to_dict") else x, value))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(
                    map(
                        lambda item: (item[0], item[1].to_dict()) if hasattr(item[1], "to_dict") else item,
                        value.items(),
                    )
                )
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """

        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """

        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """

        if not isinstance(other, MetricDetail):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """

        if not isinstance(other, MetricDetail):
            return True

        return self.to_dict() != other.to_dict()
