# coding: utf-8

"""
    UbiOps

    Client Library to interact with the UbiOps API.

    The version of the OpenAPI document: v2.1
    Generated by: https://openapi-generator.tech
"""


import pprint


class PipelineVersionDetail(object):
    """
    NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name and the value is attribute type
      attribute_map (dict): The key is attribute name and the value is json key in definition
    """

    openapi_types = {
        "id": "str",
        "version": "str",
        "default": "bool",
        "pipeline": "str",
        "description": "str",
        "labels": "dict(str, str)",
        "creation_date": "datetime",
        "last_updated": "datetime",
        "monitoring": "str",
        "request_retention_time": "int",
        "request_retention_mode": "str",
        "default_notification_group": "str",
        "objects": "list[PipelineVersionObjectList]",
        "attachments": "list[AttachmentsList]",
    }

    attribute_map = {
        "id": "id",
        "version": "version",
        "default": "default",
        "pipeline": "pipeline",
        "description": "description",
        "labels": "labels",
        "creation_date": "creation_date",
        "last_updated": "last_updated",
        "monitoring": "monitoring",
        "request_retention_time": "request_retention_time",
        "request_retention_mode": "request_retention_mode",
        "default_notification_group": "default_notification_group",
        "objects": "objects",
        "attachments": "attachments",
    }

    def __init__(
        self,
        id=None,
        version=None,
        default=None,
        pipeline=None,
        description=None,
        labels=None,
        creation_date=None,
        last_updated=None,
        monitoring=None,
        request_retention_time=None,
        request_retention_mode=None,
        default_notification_group=None,
        objects=None,
        attachments=None,
        **kwargs,
    ):
        """
        PipelineVersionDetail - a model defined in OpenAPI
        """

        self.client_side_validation = True
        if "local_vars_configuration" in kwargs and kwargs["local_vars_configuration"] is not None:
            self.client_side_validation = kwargs["local_vars_configuration"].client_side_validation

        self._id = None
        self._version = None
        self._default = None
        self._pipeline = None
        self._description = None
        self._labels = None
        self._creation_date = None
        self._last_updated = None
        self._monitoring = None
        self._request_retention_time = None
        self._request_retention_mode = None
        self._default_notification_group = None
        self._objects = None
        self._attachments = None
        self.discriminator = None

        if id is not None:
            self.id = id
        self.version = version
        self.default = default
        self.pipeline = pipeline
        if description is not None:
            self.description = description
        if labels is not None:
            self.labels = labels
        if creation_date is not None:
            self.creation_date = creation_date
        if last_updated is not None:
            self.last_updated = last_updated
        if monitoring is not None:
            self.monitoring = monitoring
        if request_retention_time is not None:
            self.request_retention_time = request_retention_time
        self.request_retention_mode = request_retention_mode
        if default_notification_group is not None:
            self.default_notification_group = default_notification_group
        if objects is not None:
            self.objects = objects
        if attachments is not None:
            self.attachments = attachments

    @property
    def id(self):
        """
        Gets the id of this PipelineVersionDetail

        :return: the id of this PipelineVersionDetail
        :rtype: str
        """

        return self._id

    @id.setter
    def id(self, id):
        """
        Sets the id of this PipelineVersionDetail

        :param id: the id of this PipelineVersionDetail
        :type: str
        """

        if self.client_side_validation and (id is not None and not isinstance(id, str)):
            raise ValueError("Parameter `id` must be a string")

        self._id = id

    @property
    def version(self):
        """
        Gets the version of this PipelineVersionDetail

        :return: the version of this PipelineVersionDetail
        :rtype: str
        """

        return self._version

    @version.setter
    def version(self, version):
        """
        Sets the version of this PipelineVersionDetail

        :param version: the version of this PipelineVersionDetail
        :type: str
        """

        if self.client_side_validation and version is None:
            raise ValueError("Invalid value for `version`, must not be `None`")
        if self.client_side_validation and (version is not None and not isinstance(version, str)):
            raise ValueError("Parameter `version` must be a string")

        if self.client_side_validation and (version is not None and len(version) > 64):
            raise ValueError("Invalid value for `version`, length must be less than or equal to `64`")
        if self.client_side_validation and (version is not None and len(version) < 1):
            raise ValueError("Invalid value for `version`, length must be greater than or equal to `1`")

        self._version = version

    @property
    def default(self):
        """
        Gets the default of this PipelineVersionDetail

        :return: the default of this PipelineVersionDetail
        :rtype: bool
        """

        return self._default

    @default.setter
    def default(self, default):
        """
        Sets the default of this PipelineVersionDetail

        :param default: the default of this PipelineVersionDetail
        :type: bool
        """

        if self.client_side_validation and (default is not None and not isinstance(default, bool)):
            raise ValueError("Parameter `default` must be a boolean")

        self._default = default

    @property
    def pipeline(self):
        """
        Gets the pipeline of this PipelineVersionDetail

        :return: the pipeline of this PipelineVersionDetail
        :rtype: str
        """

        return self._pipeline

    @pipeline.setter
    def pipeline(self, pipeline):
        """
        Sets the pipeline of this PipelineVersionDetail

        :param pipeline: the pipeline of this PipelineVersionDetail
        :type: str
        """

        if self.client_side_validation and pipeline is None:
            raise ValueError("Invalid value for `pipeline`, must not be `None`")
        if self.client_side_validation and (pipeline is not None and not isinstance(pipeline, str)):
            raise ValueError("Parameter `pipeline` must be a string")

        if self.client_side_validation and (pipeline is not None and len(pipeline) < 1):
            raise ValueError("Invalid value for `pipeline`, length must be greater than or equal to `1`")

        self._pipeline = pipeline

    @property
    def description(self):
        """
        Gets the description of this PipelineVersionDetail

        :return: the description of this PipelineVersionDetail
        :rtype: str
        """

        return self._description

    @description.setter
    def description(self, description):
        """
        Sets the description of this PipelineVersionDetail

        :param description: the description of this PipelineVersionDetail
        :type: str
        """

        if self.client_side_validation and (description is not None and not isinstance(description, str)):
            raise ValueError("Parameter `description` must be a string")

        if self.client_side_validation and (description is not None and len(description) > 400):
            raise ValueError("Invalid value for `description`, length must be less than or equal to `400`")

        self._description = description

    @property
    def labels(self):
        """
        Gets the labels of this PipelineVersionDetail

        :return: the labels of this PipelineVersionDetail
        :rtype: dict(str, str)
        """

        return self._labels

    @labels.setter
    def labels(self, labels):
        """
        Sets the labels of this PipelineVersionDetail

        :param labels: the labels of this PipelineVersionDetail
        :type: dict(str, str)
        """

        if self.client_side_validation and (labels is not None and not isinstance(labels, dict)):
            raise ValueError("Parameter `labels` must be a dictionary")

        self._labels = labels

    @property
    def creation_date(self):
        """
        Gets the creation_date of this PipelineVersionDetail

        :return: the creation_date of this PipelineVersionDetail
        :rtype: datetime
        """

        return self._creation_date

    @creation_date.setter
    def creation_date(self, creation_date):
        """
        Sets the creation_date of this PipelineVersionDetail

        :param creation_date: the creation_date of this PipelineVersionDetail
        :type: datetime
        """

        self._creation_date = creation_date

    @property
    def last_updated(self):
        """
        Gets the last_updated of this PipelineVersionDetail

        :return: the last_updated of this PipelineVersionDetail
        :rtype: datetime
        """

        return self._last_updated

    @last_updated.setter
    def last_updated(self, last_updated):
        """
        Sets the last_updated of this PipelineVersionDetail

        :param last_updated: the last_updated of this PipelineVersionDetail
        :type: datetime
        """

        self._last_updated = last_updated

    @property
    def monitoring(self):
        """
        Gets the monitoring of this PipelineVersionDetail

        :return: the monitoring of this PipelineVersionDetail
        :rtype: str
        """

        return self._monitoring

    @monitoring.setter
    def monitoring(self, monitoring):
        """
        Sets the monitoring of this PipelineVersionDetail

        :param monitoring: the monitoring of this PipelineVersionDetail
        :type: str
        """

        if self.client_side_validation and (monitoring is not None and not isinstance(monitoring, str)):
            raise ValueError("Parameter `monitoring` must be a string")

        self._monitoring = monitoring

    @property
    def request_retention_time(self):
        """
        Gets the request_retention_time of this PipelineVersionDetail

        :return: the request_retention_time of this PipelineVersionDetail
        :rtype: int
        """

        return self._request_retention_time

    @request_retention_time.setter
    def request_retention_time(self, request_retention_time):
        """
        Sets the request_retention_time of this PipelineVersionDetail

        :param request_retention_time: the request_retention_time of this PipelineVersionDetail
        :type: int
        """

        if self.client_side_validation and (
            request_retention_time is not None and not isinstance(request_retention_time, int)
        ):
            raise ValueError("Parameter `request_retention_time` must be an integer")

        self._request_retention_time = request_retention_time

    @property
    def request_retention_mode(self):
        """
        Gets the request_retention_mode of this PipelineVersionDetail

        :return: the request_retention_mode of this PipelineVersionDetail
        :rtype: str
        """

        return self._request_retention_mode

    @request_retention_mode.setter
    def request_retention_mode(self, request_retention_mode):
        """
        Sets the request_retention_mode of this PipelineVersionDetail

        :param request_retention_mode: the request_retention_mode of this PipelineVersionDetail
        :type: str
        """

        if self.client_side_validation and request_retention_mode is None:
            raise ValueError("Invalid value for `request_retention_mode`, must not be `None`")
        if self.client_side_validation and (
            request_retention_mode is not None and not isinstance(request_retention_mode, str)
        ):
            raise ValueError("Parameter `request_retention_mode` must be a string")

        if self.client_side_validation and (request_retention_mode is not None and len(request_retention_mode) < 1):
            raise ValueError("Invalid value for `request_retention_mode`, length must be greater than or equal to `1`")

        self._request_retention_mode = request_retention_mode

    @property
    def default_notification_group(self):
        """
        Gets the default_notification_group of this PipelineVersionDetail

        :return: the default_notification_group of this PipelineVersionDetail
        :rtype: str
        """

        return self._default_notification_group

    @default_notification_group.setter
    def default_notification_group(self, default_notification_group):
        """
        Sets the default_notification_group of this PipelineVersionDetail

        :param default_notification_group: the default_notification_group of this PipelineVersionDetail
        :type: str
        """

        if self.client_side_validation and (
            default_notification_group is not None and not isinstance(default_notification_group, str)
        ):
            raise ValueError("Parameter `default_notification_group` must be a string")

        self._default_notification_group = default_notification_group

    @property
    def objects(self):
        """
        Gets the objects of this PipelineVersionDetail

        :return: the objects of this PipelineVersionDetail
        :rtype: list[PipelineVersionObjectList]
        """

        return self._objects

    @objects.setter
    def objects(self, objects):
        """
        Sets the objects of this PipelineVersionDetail

        :param objects: the objects of this PipelineVersionDetail
        :type: list[PipelineVersionObjectList]
        """

        if self.client_side_validation and (objects is not None and not isinstance(objects, list)):
            raise ValueError("Parameter `objects` must be a list")
        if self.client_side_validation and objects is not None:
            from ubiops.models.pipeline_version_object_list import PipelineVersionObjectList

            objects = [PipelineVersionObjectList(**item) if isinstance(item, dict) else item for item in objects]

        self._objects = objects

    @property
    def attachments(self):
        """
        Gets the attachments of this PipelineVersionDetail

        :return: the attachments of this PipelineVersionDetail
        :rtype: list[AttachmentsList]
        """

        return self._attachments

    @attachments.setter
    def attachments(self, attachments):
        """
        Sets the attachments of this PipelineVersionDetail

        :param attachments: the attachments of this PipelineVersionDetail
        :type: list[AttachmentsList]
        """

        if self.client_side_validation and (attachments is not None and not isinstance(attachments, list)):
            raise ValueError("Parameter `attachments` must be a list")
        if self.client_side_validation and attachments is not None:
            from ubiops.models.attachments_list import AttachmentsList

            attachments = [AttachmentsList(**item) if isinstance(item, dict) else item for item in attachments]

        self._attachments = attachments

    def to_dict(self):
        """
        Returns the model properties as a dict
        """

        result = {}

        for attr, _ in self.openapi_types.items():
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(lambda x: x.to_dict() if hasattr(x, "to_dict") else x, value))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(
                    map(
                        lambda item: (item[0], item[1].to_dict()) if hasattr(item[1], "to_dict") else item,
                        value.items(),
                    )
                )
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """

        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """

        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """

        if not isinstance(other, PipelineVersionDetail):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """

        if not isinstance(other, PipelineVersionDetail):
            return True

        return self.to_dict() != other.to_dict()
