# coding: utf-8

"""
    UbiOps

    Client Library to interact with the UbiOps API.

    The version of the OpenAPI document: v2.1
    Generated by: https://openapi-generator.tech
"""


import pprint


class QuotaDetail(object):
    """
    NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name and the value is attribute type
      attribute_map (dict): The key is attribute name and the value is json key in definition
    """

    openapi_types = {"resource": "str", "quota": "float"}

    attribute_map = {"resource": "resource", "quota": "quota"}

    def __init__(self, resource=None, quota=None, **kwargs):
        """
        QuotaDetail - a model defined in OpenAPI
        """

        self.client_side_validation = True
        if "local_vars_configuration" in kwargs and kwargs["local_vars_configuration"] is not None:
            self.client_side_validation = kwargs["local_vars_configuration"].client_side_validation

        self._resource = None
        self._quota = None
        self.discriminator = None

        self.resource = resource
        self.quota = quota

    @property
    def resource(self):
        """
        Gets the resource of this QuotaDetail

        :return: the resource of this QuotaDetail
        :rtype: str
        """

        return self._resource

    @resource.setter
    def resource(self, resource):
        """
        Sets the resource of this QuotaDetail

        :param resource: the resource of this QuotaDetail
        :type: str
        """

        if self.client_side_validation and resource is None:
            raise ValueError("Invalid value for `resource`, must not be `None`")
        if self.client_side_validation and (resource is not None and not isinstance(resource, str)):
            raise ValueError("Parameter `resource` must be a string")

        if self.client_side_validation and (resource is not None and len(resource) < 1):
            raise ValueError("Invalid value for `resource`, length must be greater than or equal to `1`")

        self._resource = resource

    @property
    def quota(self):
        """
        Gets the quota of this QuotaDetail

        :return: the quota of this QuotaDetail
        :rtype: float
        """

        return self._quota

    @quota.setter
    def quota(self, quota):
        """
        Sets the quota of this QuotaDetail

        :param quota: the quota of this QuotaDetail
        :type: float
        """

        if self.client_side_validation and quota is None:
            raise ValueError("Invalid value for `quota`, must not be `None`")
        if self.client_side_validation and (quota is not None and not isinstance(quota, (int, float))):
            raise ValueError("Parameter `quota` must be a float")

        self._quota = quota

    def to_dict(self):
        """
        Returns the model properties as a dict
        """

        result = {}

        for attr, _ in self.openapi_types.items():
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(lambda x: x.to_dict() if hasattr(x, "to_dict") else x, value))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(
                    map(
                        lambda item: (item[0], item[1].to_dict()) if hasattr(item[1], "to_dict") else item,
                        value.items(),
                    )
                )
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """

        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """

        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """

        if not isinstance(other, QuotaDetail):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """

        if not isinstance(other, QuotaDetail):
            return True

        return self.to_dict() != other.to_dict()
