# coding: utf-8

"""
    UbiOps

    Client Library to interact with the UbiOps API.

    The version of the OpenAPI document: v2.1
    Generated by: https://openapi-generator.tech
"""


import pprint


class RoleCreate(object):
    """
    NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name and the value is attribute type
      attribute_map (dict): The key is attribute name and the value is json key in definition
    """

    openapi_types = {"name": "str", "permissions": "list[str]"}

    attribute_map = {"name": "name", "permissions": "permissions"}

    def __init__(self, name=None, permissions=None, **kwargs):
        """
        RoleCreate - a model defined in OpenAPI
        """

        self.client_side_validation = True
        if "local_vars_configuration" in kwargs and kwargs["local_vars_configuration"] is not None:
            self.client_side_validation = kwargs["local_vars_configuration"].client_side_validation

        self._name = None
        self._permissions = None
        self.discriminator = None

        self.name = name
        self.permissions = permissions

    @property
    def name(self):
        """
        Gets the name of this RoleCreate

        :return: the name of this RoleCreate
        :rtype: str
        """

        return self._name

    @name.setter
    def name(self, name):
        """
        Sets the name of this RoleCreate

        :param name: the name of this RoleCreate
        :type: str
        """

        if self.client_side_validation and name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")
        if self.client_side_validation and (name is not None and not isinstance(name, str)):
            raise ValueError("Parameter `name` must be a string")

        if self.client_side_validation and (name is not None and len(name) < 1):
            raise ValueError("Invalid value for `name`, length must be greater than or equal to `1`")

        self._name = name

    @property
    def permissions(self):
        """
        Gets the permissions of this RoleCreate

        :return: the permissions of this RoleCreate
        :rtype: list[str]
        """

        return self._permissions

    @permissions.setter
    def permissions(self, permissions):
        """
        Sets the permissions of this RoleCreate

        :param permissions: the permissions of this RoleCreate
        :type: list[str]
        """

        if self.client_side_validation and permissions is None:
            raise ValueError("Invalid value for `permissions`, must not be `None`")
        if self.client_side_validation and (permissions is not None and not isinstance(permissions, list)):
            raise ValueError("Parameter `permissions` must be a list")

        self._permissions = permissions

    def to_dict(self):
        """
        Returns the model properties as a dict
        """

        result = {}

        for attr, _ in self.openapi_types.items():
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(lambda x: x.to_dict() if hasattr(x, "to_dict") else x, value))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(
                    map(
                        lambda item: (item[0], item[1].to_dict()) if hasattr(item[1], "to_dict") else item,
                        value.items(),
                    )
                )
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """

        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """

        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """

        if not isinstance(other, RoleCreate):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """

        if not isinstance(other, RoleCreate):
            return True

        return self.to_dict() != other.to_dict()
