# coding: utf-8

"""
    UbiOps

    Client Library to interact with the UbiOps API.

    The version of the OpenAPI document: v2.1
    Generated by: https://openapi-generator.tech
"""


import pprint


class TimeSeriesSearch(object):
    """
    NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name and the value is attribute type
      attribute_map (dict): The key is attribute name and the value is json key in definition
    """

    openapi_types = {"id": "int", "metric": "str", "labels": "dict(str, str)", "resolution": "int"}

    attribute_map = {"id": "id", "metric": "metric", "labels": "labels", "resolution": "resolution"}

    def __init__(self, id=None, metric=None, labels=None, resolution=None, **kwargs):
        """
        TimeSeriesSearch - a model defined in OpenAPI
        """

        self.client_side_validation = True
        if "local_vars_configuration" in kwargs and kwargs["local_vars_configuration"] is not None:
            self.client_side_validation = kwargs["local_vars_configuration"].client_side_validation

        self._id = None
        self._metric = None
        self._labels = None
        self._resolution = None
        self.discriminator = None

        self.id = id
        self.metric = metric
        self.labels = labels
        if resolution is not None:
            self.resolution = resolution

    @property
    def id(self):
        """
        Gets the id of this TimeSeriesSearch

        :return: the id of this TimeSeriesSearch
        :rtype: int
        """

        return self._id

    @id.setter
    def id(self, id):
        """
        Sets the id of this TimeSeriesSearch

        :param id: the id of this TimeSeriesSearch
        :type: int
        """

        if self.client_side_validation and id is None:
            raise ValueError("Invalid value for `id`, must not be `None`")
        if self.client_side_validation and (id is not None and not isinstance(id, int)):
            raise ValueError("Parameter `id` must be an integer")

        self._id = id

    @property
    def metric(self):
        """
        Gets the metric of this TimeSeriesSearch

        :return: the metric of this TimeSeriesSearch
        :rtype: str
        """

        return self._metric

    @metric.setter
    def metric(self, metric):
        """
        Sets the metric of this TimeSeriesSearch

        :param metric: the metric of this TimeSeriesSearch
        :type: str
        """

        if self.client_side_validation and metric is None:
            raise ValueError("Invalid value for `metric`, must not be `None`")
        if self.client_side_validation and (metric is not None and not isinstance(metric, str)):
            raise ValueError("Parameter `metric` must be a string")

        if self.client_side_validation and (metric is not None and len(metric) < 1):
            raise ValueError("Invalid value for `metric`, length must be greater than or equal to `1`")

        self._metric = metric

    @property
    def labels(self):
        """
        Gets the labels of this TimeSeriesSearch

        :return: the labels of this TimeSeriesSearch
        :rtype: dict(str, str)
        """

        return self._labels

    @labels.setter
    def labels(self, labels):
        """
        Sets the labels of this TimeSeriesSearch

        :param labels: the labels of this TimeSeriesSearch
        :type: dict(str, str)
        """

        if self.client_side_validation and labels is None:
            raise ValueError("Invalid value for `labels`, must not be `None`")
        if self.client_side_validation and (labels is not None and not isinstance(labels, dict)):
            raise ValueError("Parameter `labels` must be a dictionary")

        self._labels = labels

    @property
    def resolution(self):
        """
        Gets the resolution of this TimeSeriesSearch

        :return: the resolution of this TimeSeriesSearch
        :rtype: int
        """

        return self._resolution

    @resolution.setter
    def resolution(self, resolution):
        """
        Sets the resolution of this TimeSeriesSearch

        :param resolution: the resolution of this TimeSeriesSearch
        :type: int
        """

        if self.client_side_validation and (resolution is not None and not isinstance(resolution, int)):
            raise ValueError("Parameter `resolution` must be an integer")

        self._resolution = resolution

    def to_dict(self):
        """
        Returns the model properties as a dict
        """

        result = {}

        for attr, _ in self.openapi_types.items():
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(lambda x: x.to_dict() if hasattr(x, "to_dict") else x, value))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(
                    map(
                        lambda item: (item[0], item[1].to_dict()) if hasattr(item[1], "to_dict") else item,
                        value.items(),
                    )
                )
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """

        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """

        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """

        if not isinstance(other, TimeSeriesSearch):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """

        if not isinstance(other, TimeSeriesSearch):
            return True

        return self.to_dict() != other.to_dict()
