# coding: utf-8

"""
    UbiOps

    Client Library to interact with the UbiOps API.

    The version of the OpenAPI document: v2.1
    Generated by: https://openapi-generator.tech
"""


import pprint


class WebhookUpdate(object):
    """
    NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name and the value is attribute type
      attribute_map (dict): The key is attribute name and the value is json key in definition
    """

    openapi_types = {
        "name": "str",
        "url": "str",
        "headers": "list[WebhookHeader]",
        "event": "str",
        "description": "str",
        "labels": "dict(str, str)",
        "timeout": "int",
        "enabled": "bool",
        "retry": "bool",
        "include_result": "bool",
    }

    attribute_map = {
        "name": "name",
        "url": "url",
        "headers": "headers",
        "event": "event",
        "description": "description",
        "labels": "labels",
        "timeout": "timeout",
        "enabled": "enabled",
        "retry": "retry",
        "include_result": "include_result",
    }

    def __init__(
        self,
        name=None,
        url=None,
        headers=None,
        event=None,
        description=None,
        labels=None,
        timeout=None,
        enabled=None,
        retry=None,
        include_result=None,
        **kwargs,
    ):
        """
        WebhookUpdate - a model defined in OpenAPI
        """

        self.client_side_validation = True
        if "local_vars_configuration" in kwargs and kwargs["local_vars_configuration"] is not None:
            self.client_side_validation = kwargs["local_vars_configuration"].client_side_validation

        self._name = None
        self._url = None
        self._headers = None
        self._event = None
        self._description = None
        self._labels = None
        self._timeout = None
        self._enabled = None
        self._retry = None
        self._include_result = None
        self.discriminator = None

        if name is not None:
            self.name = name
        if url is not None:
            self.url = url
        if headers is not None:
            self.headers = headers
        if event is not None:
            self.event = event
        if description is not None:
            self.description = description
        if labels is not None:
            self.labels = labels
        if timeout is not None:
            self.timeout = timeout
        if enabled is not None:
            self.enabled = enabled
        if retry is not None:
            self.retry = retry
        if include_result is not None:
            self.include_result = include_result

    @property
    def name(self):
        """
        Gets the name of this WebhookUpdate

        :return: the name of this WebhookUpdate
        :rtype: str
        """

        return self._name

    @name.setter
    def name(self, name):
        """
        Sets the name of this WebhookUpdate

        :param name: the name of this WebhookUpdate
        :type: str
        """

        if self.client_side_validation and (name is not None and not isinstance(name, str)):
            raise ValueError("Parameter `name` must be a string")

        if self.client_side_validation and (name is not None and len(name) < 1):
            raise ValueError("Invalid value for `name`, length must be greater than or equal to `1`")

        self._name = name

    @property
    def url(self):
        """
        Gets the url of this WebhookUpdate

        :return: the url of this WebhookUpdate
        :rtype: str
        """

        return self._url

    @url.setter
    def url(self, url):
        """
        Sets the url of this WebhookUpdate

        :param url: the url of this WebhookUpdate
        :type: str
        """

        if self.client_side_validation and (url is not None and not isinstance(url, str)):
            raise ValueError("Parameter `url` must be a string")

        self._url = url

    @property
    def headers(self):
        """
        Gets the headers of this WebhookUpdate

        :return: the headers of this WebhookUpdate
        :rtype: list[WebhookHeader]
        """

        return self._headers

    @headers.setter
    def headers(self, headers):
        """
        Sets the headers of this WebhookUpdate

        :param headers: the headers of this WebhookUpdate
        :type: list[WebhookHeader]
        """

        if self.client_side_validation and (headers is not None and not isinstance(headers, list)):
            raise ValueError("Parameter `headers` must be a list")
        if self.client_side_validation and headers is not None:
            from ubiops.models.webhook_header import WebhookHeader

            headers = [WebhookHeader(**item) if isinstance(item, dict) else item for item in headers]

        self._headers = headers

    @property
    def event(self):
        """
        Gets the event of this WebhookUpdate

        :return: the event of this WebhookUpdate
        :rtype: str
        """

        return self._event

    @event.setter
    def event(self, event):
        """
        Sets the event of this WebhookUpdate

        :param event: the event of this WebhookUpdate
        :type: str
        """

        if self.client_side_validation and (event is not None and not isinstance(event, str)):
            raise ValueError("Parameter `event` must be a string")

        self._event = event

    @property
    def description(self):
        """
        Gets the description of this WebhookUpdate

        :return: the description of this WebhookUpdate
        :rtype: str
        """

        return self._description

    @description.setter
    def description(self, description):
        """
        Sets the description of this WebhookUpdate

        :param description: the description of this WebhookUpdate
        :type: str
        """

        if self.client_side_validation and (description is not None and not isinstance(description, str)):
            raise ValueError("Parameter `description` must be a string")

        self._description = description

    @property
    def labels(self):
        """
        Gets the labels of this WebhookUpdate

        :return: the labels of this WebhookUpdate
        :rtype: dict(str, str)
        """

        return self._labels

    @labels.setter
    def labels(self, labels):
        """
        Sets the labels of this WebhookUpdate

        :param labels: the labels of this WebhookUpdate
        :type: dict(str, str)
        """

        if self.client_side_validation and (labels is not None and not isinstance(labels, dict)):
            raise ValueError("Parameter `labels` must be a dictionary")

        self._labels = labels

    @property
    def timeout(self):
        """
        Gets the timeout of this WebhookUpdate

        :return: the timeout of this WebhookUpdate
        :rtype: int
        """

        return self._timeout

    @timeout.setter
    def timeout(self, timeout):
        """
        Sets the timeout of this WebhookUpdate

        :param timeout: the timeout of this WebhookUpdate
        :type: int
        """

        if self.client_side_validation and (timeout is not None and not isinstance(timeout, int)):
            raise ValueError("Parameter `timeout` must be an integer")

        self._timeout = timeout

    @property
    def enabled(self):
        """
        Gets the enabled of this WebhookUpdate

        :return: the enabled of this WebhookUpdate
        :rtype: bool
        """

        return self._enabled

    @enabled.setter
    def enabled(self, enabled):
        """
        Sets the enabled of this WebhookUpdate

        :param enabled: the enabled of this WebhookUpdate
        :type: bool
        """

        if self.client_side_validation and (enabled is not None and not isinstance(enabled, bool)):
            raise ValueError("Parameter `enabled` must be a boolean")

        self._enabled = enabled

    @property
    def retry(self):
        """
        Gets the retry of this WebhookUpdate

        :return: the retry of this WebhookUpdate
        :rtype: bool
        """

        return self._retry

    @retry.setter
    def retry(self, retry):
        """
        Sets the retry of this WebhookUpdate

        :param retry: the retry of this WebhookUpdate
        :type: bool
        """

        if self.client_side_validation and (retry is not None and not isinstance(retry, bool)):
            raise ValueError("Parameter `retry` must be a boolean")

        self._retry = retry

    @property
    def include_result(self):
        """
        Gets the include_result of this WebhookUpdate

        :return: the include_result of this WebhookUpdate
        :rtype: bool
        """

        return self._include_result

    @include_result.setter
    def include_result(self, include_result):
        """
        Sets the include_result of this WebhookUpdate

        :param include_result: the include_result of this WebhookUpdate
        :type: bool
        """

        if self.client_side_validation and (include_result is not None and not isinstance(include_result, bool)):
            raise ValueError("Parameter `include_result` must be a boolean")

        self._include_result = include_result

    def to_dict(self):
        """
        Returns the model properties as a dict
        """

        result = {}

        for attr, _ in self.openapi_types.items():
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(lambda x: x.to_dict() if hasattr(x, "to_dict") else x, value))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(
                    map(
                        lambda item: (item[0], item[1].to_dict()) if hasattr(item[1], "to_dict") else item,
                        value.items(),
                    )
                )
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """

        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """

        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """

        if not isinstance(other, WebhookUpdate):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """

        if not isinstance(other, WebhookUpdate):
            return True

        return self.to_dict() != other.to_dict()
